/*
 * $Id: UnsupportedTypeException.java 4223 2011-02-04 23:01:46Z mitza $
 *
 *
 * Distributed under the OpenDDS License.
 * See: http://www.opendds.org/license.html
 */

package org.opendds.jms.common.beans;

/**
 * @author  Steven Stallion
 * @version $Revision: 4223 $
 */
public class UnsupportedTypeException extends RuntimeException {

    /**
     * @throws  NullPointerException if o is null
     */
    public UnsupportedTypeException(Object o) {
        this(o.getClass());
    }

    /**
     * @throws  NullPointerException if clazz is null
     */
    public UnsupportedTypeException(Class clazz) {
        this(clazz.getName());
    }

    public UnsupportedTypeException(String message) {
        super(message);
    }
}
